// MyFileDialogDoc.cpp : implementation of the CMyFileDialogDoc class
//

#include "stdafx.h"
#include "MyFileDialog.h"

#include "MyFileDialogDoc.h"
#include "FileDialogEx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyFileDialogDoc

IMPLEMENT_DYNCREATE(CMyFileDialogDoc, CDocument)

BEGIN_MESSAGE_MAP(CMyFileDialogDoc, CDocument)
	//{{AFX_MSG_MAP(CMyFileDialogDoc)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyFileDialogDoc construction/destruction

CMyFileDialogDoc::CMyFileDialogDoc()
{
	// TODO: add one-time construction code here
	m_nDocSubType = 0;	// default subtype
}

CMyFileDialogDoc::~CMyFileDialogDoc()
{
}

BOOL CMyFileDialogDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMyFileDialogDoc serialization

void CMyFileDialogDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMyFileDialogDoc diagnostics

#ifdef _DEBUG
void CMyFileDialogDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMyFileDialogDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMyFileDialogDoc commands

void CMyFileDialogDoc::OnFileSaveAs() 
{
	// TODO: Add your command handler code here
	// Call our Save As dialog box
	CFileDialogEx filedialog(FALSE, NULL, GetTitle(),
		OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		NULL);

	// pass document subtype to our SaveAs dialog box
	filedialog.m_nSubType = m_nDocSubType;
	filedialog.m_ofn.lpstrTitle = "User added controls - Save File As";

	// display our dialog
	if (filedialog.DoModal() == IDOK)
	{
		// get/save document subtype
		m_nDocSubType = filedialog.m_nSubType;
		
		char szText[100];
		sprintf(szText, "Document will be saved under subtype %d", m_nDocSubType);
		AfxMessageBox(szText);

		// do your own SaveAs procedure or call document default
		// CDocument::OnSaveDocument()
	}
	
	// error hanling (if any)
	// ...
}
